unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    opdSel: TOpenDialog;
    bConv: TButton;
    rgConvD: TRadioGroup;
    pbPr: TProgressBar;
    stInf: TStaticText;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bConvClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
	if opdSel.Execute then begin
  	bConv.Enabled:=true;
    //stInf.Visible:=true;
    stInf.Caption:=IntToStr(opdSel.Files.Count)+
    	' file(s) selected';
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	opdSel.InitialDir:=ExtractFilePath(Application.ExeName);
end;

procedure TForm1.bConvClick(Sender: TObject);
var
	INF, OUF: TextFile;
  i: integer;
  cs, fn, s1, sv, s2: string;
begin
	pbPr.Min:=0;
	pbPr.Max:=opdSel.Files.Count;
	pbPr.Position:=pbPr.Min;
  case rgConvD.ItemIndex of
  	0: cs:='ANSI_';
    1: cs:='OEM_';
  end;
	for i:=0 to opdSel.Files.Count-1 do begin
    stInf.Caption:='Converting '+IntToStr(i+1)+' file of '+
    	IntToStr(opdSel.Files.Count);
  	AssignFile(INF,opdSel.Files[i]);
    //ShowMessage('INF = "'+opdSel.Files[i]+'"');
    fn:=ExtractFilePath(opdSel.Files[i])+cs+
    	ExtractFileName(opdSel.Files[i]);
    //ShowMessage(fn);
  	AssignFile(OUF,fn);
    //ShowMessage('OUF = "'+fn+'"');
    //ShowMessage('opening INF...');
    reset(INF);
    //ShowMessage('creating OUF...');
    rewrite(OUF);
    //ShowMessage('conversion loop...');
    while not EOF(INF) do begin
	    //ShowMessage('read data...');
    	readln(INF,s1);
	    //ShowMessage('conversion data...');
      sv:=copy(s1,1,length(s1));
		  case rgConvD.ItemIndex of
		  	0: OemToCharBuff(PChar(sv),PChar(sv),length(sv));
		    1: CharToOemBuff(PChar(sv),PChar(sv),length(sv));
		  end;
	    //ShowMessage('write data...');
      s2:=copy(sv,1,length(sv));
    	writeln(OUF,s2);
    end;
    //ShowMessage('closing INF...');
    CloseFile(INF);
    //ShowMessage('closing OUF...');
    CloseFile(OUF);
    pbPr.StepIt;
  end;
  stInf.Caption:='Work complete';
end;

end.
